unit uTable;

interface

uses Rubies;

var
  cTable: Tvalue;

procedure Init_Table;

implementation

uses SysUtils, Pythia, SqlExpr, uDataSet, uRDB, uFieldDef, uIndexDef;

function Table_new(argc: integer; argv: Pointer; This: Tvalue): Tvalue; cdecl;
var
  real: TSQLTable;
begin
  real := TSQLTable.Create(nil);
  result := DataSet_alloc1(This, real);
  DataSet_setup(result, real);

  rb_iv_set(result, '@field_defs', FieldDefs_alloc(cFieldDefs, real.FieldDefs));
  rb_iv_set(result, '@index_defs', IndexDefs_alloc(cIndexDefs, real.IndexDefs));

  rb_obj_call_init(result, argc, argv);
end;

procedure Init_Table;
begin
  cTable := DefineCompoClass(mRDB, TSQLTable, cDataSet, nil);
  DefineSingletonMethod(cTable, 'new', Table_new);
end;

end.
