unit uStoredProc;

interface

uses Rubies;

var
  cStoredProc: Tvalue;

procedure Init_StoredProc;

implementation

uses SqlExpr, Pythia, uRDB;

function StoredProc_new(argc: integer; argv: Pointer; This: Tvalue): Tvalue; cdecl;
var
  real: TSQLStoredProc;
begin
  real := TSQLStoredProc.Create(nil);
  result := CompoAlloc(This, real);
  CompoSetup(argc, argv, real);

  rb_obj_call_init(result, argc, argv);
end;

procedure Init_StoredProc;
begin
  cStoredProc := DefineCompoClass(mRDB, TSQLStoredProc, ap_cObject, nil);
  DefineSingletonMethod(cStoredProc, 'new', StoredProc_new);
end;

end.
